package org.apache.maven.deploy.deployers;

/* ====================================================================
 * The Apache Software License, Version 1.1
 *
 * Copyright (c) 2001 The Apache Software Foundation.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "Apache" and "Apache Software Foundation" and
 *    "Apache MavenSession" must not be used to endorse or promote products
 *    derived from this software without prior written permission. For
 *    written permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache",
 *    "Apache MavenSession", nor may "Apache" appear in their name, without
 *    prior written permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 *
 * ====================================================================
 */

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

import org.apache.commons.httpclient.Credentials;
import org.apache.commons.httpclient.Header;
import org.apache.commons.httpclient.HostConfiguration;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpException;
import org.apache.commons.httpclient.UsernamePasswordCredentials;
import org.apache.commons.httpclient.methods.PutMethod;
import org.apache.maven.deploy.RepositoryInfo;
import org.apache.maven.deploy.DeployRequest;
import org.apache.maven.deploy.exceptions.TransferFailedException;

/**
 * An HTTP deployer based the Commons HttpClient library.
 *
 * @author <a href="mailto:jason@zenplex.com">Jason van Zyl</a>
 * @version $Id: HttpDeployer.java,v 1.5 2003/07/17 11:13:16 michal Exp $
 * 
 * @todo still have to account for differing setups for people deploying to
 *       their own sites and to the central repository.
 *
 * @todo deal with proxies
 * @todo deal with authentication
 * 
 * @todo this class in not really functional. It should be completly refactored.
 */
public class HttpDeployer extends AbstractDeployer
{
    private RepositoryInfo repoInfo;


    /**Protocol understood by by this deployer*/
    public final static String PROTOCOL = "http://";
    
    
    /* (non-Javadoc)
     * @see org.apache.maven.deploy.deployers.Deployer#init(org.apache.maven.deploy.HostInfo)
     */
    public void init(RepositoryInfo repoInfo)
        
    {
       this.repoInfo = repoInfo;   

    }

    /* (non-Javadoc)
     * @see org.apache.maven.deploy.deployers.Deployer#release()
     */
    public void release()
    {
        // TODO Auto-generated method stub

    }

    /**
     * Description of the Method
     */
    public void deploy(DeployRequest request) throws TransferFailedException
    {
        URL url = null;
        try
        {
            url = new URL(repoInfo.getUrl());
        }
        catch (MalformedURLException murle)
        {
        }

        Credentials creds =
            new UsernamePasswordCredentials(
        repoInfo.getUserName(),
        repoInfo.getPassword());                

        //create a singular HttpClient object
        HttpClient client = new HttpClient();
        

        //establish a connection within 5 seconds
        client.setConnectionTimeout(5000);

        //set username / password
        if (creds != null)
        {
            client.getState().setCredentials(null, creds);
        }

        //
        HostConfiguration hc = new HostConfiguration();
        hc.setHost(repoInfo.getHost());              
        //start a session with the webserver
        client.setHostConfiguration(hc);

        //create a method object
        PutMethod method = new PutMethod(url.getPath());
        
        try
        {
           method.setRequestBody(new FileInputStream(request.getSrcFile()));
        }
        catch(FileNotFoundException io)
        {
          throw new TransferFailedException("input file: '"+ request.getSrcFile() + " not found ");
        }  

        //turn follow redirects off
        method.setFollowRedirects(false);

        //turn strict mode on
        method.setStrictMode(false);

        //execute the method
        try
        {
            client.executeMethod(method);
        }
        catch (HttpException he)
        {
            System.err.println("Http error connecting to '" + url + "'");
            System.err.println(he.getMessage());
            System.exit(-4);
        }
        catch (IOException ioe)
        {
            System.err.println("Unable to connect to '" + url + "'");
            System.exit(-3);
        }

        //get the request headers
        Header[] requestHeaders = method.getRequestHeaders();

        //get the response headers
        Header[] responseHeaders = method.getResponseHeaders();

        //get the response body
        byte[] responseBody = method.getResponseBody();

        method.releaseConnection();
    }
}
